;;#0FAF(4015)  Border.  .
;---------------------------------------
; TSConf examples
; (C) breeze/fishbone crew 2013
;---------------------------------------

        DEVICE ZXSPECTRUM128

		org	#6000

VPage		equ	#01AF
VConfig		equ	#00AF

XOffsL		equ	#02AF
XOffsH		equ	#03AF

RAMPage3	equ	#13AF

startCode
;  ld a,7:out ($FE),a
		LD	BC,VConfig    ;  : %01-320x200, %010-256 
		LD	A,%01000010
		;LD	A,%10000010
		OUT	(C),A
;-----------------------------------------
 ld ixh,50
drlp1:
		LD	BC,RAMPage3   ;   #20   #c000
bank:	LD	A,#20         ;  
		OUT	(C),A

		LD	BC,VPage      ;  ,     #20
		OUT	(C),A

 ld hl,$A000
 ld de,($5Cf4)
 ld bc,$0505;5*(256+64)=1280
 push ix
 call $3D13
 pop ix
 ld ixl,4
 ld hl,$A000
v1:ld de,$c000
lp1:push de
 ld bc,320
 ldir
 pop de
 inc d,d
 dec ixl
 jr nz,lp1
 ld a,d:or a:jr nz,nopage
 ld a,(bank+1):inc a:ld (bank+1),a
 ld d,$c0
nopage:ld (v1+1),de
 dec ixh:jp nz,drlp1

rlp:ei:halt
;open FMAddr access from 0x8000
FMAddr     EQU #15AF
 ld bc, FMAddr
 ld a, 0x18
 out (c), a

;load CRAM
 ld de,$8000
 ld hl,pp
 ld bc,512
 ldir

;  ld hl,0,($8000+240*2),hl;????????

;close FMAddr
 ld bc, 0x15AF
 xor a
 out (c), a

 ld hl,0,(pp),hl
 ld bc,#0FAF; ,  ,  
 xor a
 out (c),a


;vv:ld a,0:inc a:and 3:ld (vv+1),a
; or a:jp nz, rlp

 ld hl,pp+32; 16 ,  
 ld de,pp+512
 ld bc,32:ldir
 
 ld hl,pp+32*2
 ld de,pp+32
 ld bc,512:ldir
;------------------- 
 ld ix,pp+32
 ld a,15
left_lp:
 exa
 ld b,(ix)
 ld c,(ix+1)
 push bc
 push ix
 pop de
 
 ld hl,de
 inc hl,hl
 ld bc,30:ldir
 pop bc
 ld (ix+30),b
 ld (ix+31),c
 ld bc,32
 add ix,bc
 exa
 dec a:jr nz, left_lp
;-------------------------------
 jp rlp
pp:incbin"pal.bin"
endCode:;		nop

 MODULE boot
Basic:
 db #00,#01; 
 DW EndLine1 - Line1
Line1:
 db #EA;REM
 ld sp,#5FE0
FileLength1:		EQU	endCode-startCode
			IF	low FileLength1=0
SectorLength1:		EQU	high FileLength1
			ELSE
SectorLength1:		EQU	1+high FileLength1
			ENDIF
 ld de,(#5CF4)
 ld hl, #6000
 ld bc,SectorLength1*256+5
 call #3d13
 jp $6000
 
 db "yo,lamer!"
 db #0D
EndLine1:
 db #00,#02
 DW EndLine2 - Line2
Line2:
 db #20,#FD,#B0
 db 34,"24572",34;clear val "24575"
 db #3A; :
 db #F9,#C0,#28,#35;randomize usr (5+256*peek val "23635"+peek val "23636"
 db #0E,#00,#00,#05,#00,#00,#2B
 db #32,#35,#36
 db #0E,#00,#00,#00,#01,#00,#2A,#BE

 db #B0
 db #22,#32,#33,#36,#33,#36,#22;"23635"
 db #2B;???
 db #BE
 db #B0
 db #22,#32,#33,#36,#33,#35,#22;"23636"
 db #29,#0D;)
 db #80
 db #AA,1,0;;;;;;;;;;;;;autorun line,change program length to -4, e.g. 83-4=79
EndLine2:
EndBasic:
 ENDMODULE



 display /d,endCode-startCode
    EMPTYTRD "wh.trd"
    SAVETRD "wh.trd", "boot.B", boot.Basic, boot.EndBasic - boot.Basic
    SAVETRD "wh.trd","wh.C",startCode,endCode-startCode
