Structure pal
  R.a
  G.a
  B.a
EndStructure

Dim vga.a(320,200)
Dim cols.pal(255)


For l=0 To 31
   cols(l)\R=0
   cols(l)\G=l*4
   cols(l)\B=l*4
 Next l
 
; 	cols(31)\R=255
; 	cols(31)\G=0
; 	cols(31)\B=255

			
SPOKES=2400
MAXX=320
MAXY=200
XCENTER=MAXX / 2
YCENTER=(MAXY / 2) - (MAXY / 4)
DIVS=SPOKES
TEXTUREWIDTH=15
TEXTUREHEIGHT=15

FACTOR  = 65536;


Dim 	spokeCalc.f(SPOKES)
Dim   spokeCosCalc.f(SPOKES)
Dim   spokeSinCalc.f(SPOKES)
 
Pi.f=3.1415926
;vga
	For i = 0   To SPOKES
		spokeCalc(i) = 2 * Pi * i / SPOKES;
        spokeCosCalc(i) = Cos(spokeCalc(i));
        spokeSinCalc(i) = Sin(spokeCalc(i));
	Next i

	For j = 1 To DIVS + 1
		z.f = -1 + (Log(2 * j / DIVS))
		divCalcX.f = (MAXX * j / DIVS);
    divCalcY.f = (MAXY * j / DIVS);
		For i = 0 To SPOKES
			x.f = divCalcX * spokeCosCalc(i)
      y.f = divCalcY * spokeSinCalc(i)
			y = y-(25 * z);
			x =x+ XCENTER;
      y =y+ YCENTER;
      
      If ((x >= 0) And (x < MAXX) And (y >= 0) And (y < MAXY))
				vga(Int(x),Int(y)) = 1+Mod(Int(i/8),TEXTUREWIDTH) + Mod(Int(j/8),TEXTUREWIDTH);*TEXTUREWIDTH
			EndIf
			
		Next i
	Next j

  
If InitSprite() And OpenWindow(0,0,0,640,480,"SineWave",#PB_Window_SystemMenu) And OpenWindowedScreen(WindowID(0),0,0,640,480,0,0,0) 
  Repeat 
        StartDrawing(ScreenOutput()) 
        For yy=0 To 200
          For xx=0 To 320
            Box(xx,yy,1,1,RGB(cols(vga(xx,yy))\R,cols(vga(xx,yy))\G,cols(vga(xx,yy))\B))
          Next xx
        Next yy
        
        yy=0;;For yy=0 To 1
          For xx=0 To 31
            Box(xx*16,yy*16,15,15,RGB(cols(xx+16*yy)\R,cols(xx+16*yy)\G,cols(xx+16*yy)\B))
          Next xx
        ;Next yy

        StopDrawing()
       
        FlipBuffers() 
      

    Until WindowEvent()=#PB_Event_CloseWindow 

    CreateFile(0,"pal.bin")

    dv=9
    For i=0 To 255
      r.a=Int(cols(i)\R/dv)
      g.a=Int(cols(i)\G/dv)
      b.a=Int(cols(i)\B/dv)

      v.u=b+g<<5+r<<10
      WriteByte(0,v&255)
      WriteByte(0,v>>8)
    Next i
    CloseFile(0)
;     
  CreateFile(0,"worm.001")
        For yy=0 To 200-1
          For xx=0 To 320-1
            WriteAsciiCharacter(0,vga(xx,yy))
          Next xx
            If yy=99
              CloseFile(0)
              CreateFile(0,"worm.002")
            EndIf
        Next yy
  
    CloseFile(0)
;Next k
  
EndIf

; IDE Options = PureBasic 4.60 (Windows - x86)
; CursorPosition = 77
; FirstLine = 48